import os
from pathlib import Path

from .version import __version__

directory = str(Path(__file__).resolve().parent)

default_solvers = ['CONOPT', 'CONVERT', 'CPLEX', 'GUSS', 'IPOPT', 'IPOPTH', 'KESTREL', 'NLPEC', 'PATH', 'SHOT']

available_solvers = ['CONOPT', 'CONVERT', 'CPLEX', 'IPOPT', 'IPOPTH', 'KESTREL', 'NLPEC', 'PATH', 'SHOT', 'BARON', 'CBC', 'CONOPT3', 'COPT', 'DICOPT', 'EXAMINER', 'EXAMINER2', 'GUROBI', 'HIGHS', 'KNITRO', 'MILES', 'MINOS', 'MOSEK', 'MPSGE', 'PATHNLP', 'SBB', 'SCIP', 'SNOPT', 'SOPLEX', 'XPRESS']

capabilities = {'ALPHAECP': ['MINLP', 'MIQCP'], 'ANTIGONE': ['NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'BARON': ['LP', 'MIP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'CBC': ['LP', 'MIP', 'RMIP'], 'CONOPT': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'CONOPT3': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'CONOPT4': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'CONVERT': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'MPEC', 'RMPEC', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP', 'EMP'], 'CONVERTOLD': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'MPEC', 'RMPEC', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'COPT': ['LP', 'MIP', 'RMIP', 'QCP', 'MIQCP', 'RMIQCP'], 'CPLEX': ['LP', 'MIP', 'RMIP', 'QCP', 'MIQCP', 'RMIQCP'], 'DE': ['EMP'], 'DECISC': ['LP'], 'DECISM': ['LP'], 'DICOPT': ['MINLP', 'MIQCP'], 'EXAMINER': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'MPEC', 'RMPEC', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'EXAMINER2': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'GAMSCHK': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'GLOMIQO': ['NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'GUROBI': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'GUSS': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'HIGHS': ['LP', 'MIP', 'RMIP'], 'IPOPT': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'IPOPTH': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'JAMS': ['EMP'], 'KESTREL': ['LP', 'MIP', 'RMIP', 'NLP', 'MCP', 'MPEC', 'RMPEC', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP', 'EMP'], 'KNITRO': ['LP', 'RMIP', 'NLP', 'MCP', 'MPEC', 'RMPEC', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'LINDO': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP', 'EMP'], 'LINDOGLOBAL': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'LOGMIP': ['EMP'], 'MILES': ['MCP'], 'MINOS': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'MOSEK': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'MPSGE': [], 'NLPEC': ['MCP', 'MPEC', 'RMPEC'], 'ODHCPLEX': ['MIP', 'MIQCP'], 'OSICPLEX': ['LP', 'MIP', 'RMIP', 'QCP', 'MIQCP', 'RMIQCP'], 'OSIGUROBI': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'OSIMOSEK': ['LP', 'MIP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'OSIXPRESS': ['LP', 'MIP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'PATH': ['MCP', 'CNS'], 'PATHNLP': ['LP', 'RMIP', 'NLP', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'QUADMINOS': ['LP', 'RMIP'], 'RESHOP': ['EMP'], 'SBB': ['MINLP', 'MIQCP'], 'SCIP': ['MIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP'], 'SHOT': ['MINLP', 'MIQCP'], 'SNOPT': ['LP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'QCP', 'RMIQCP'], 'SOPLEX': ['LP', 'RMIP'], 'XPRESS': ['LP', 'MIP', 'RMIP', 'NLP', 'CNS', 'DNLP', 'RMINLP', 'MINLP', 'QCP', 'MIQCP', 'RMIQCP']}

files = ['.uninstinfo.ini', 'co4cclib64.dll', 'conopt464.dll', 'cplex2211.dll', 'cpxcclib64.dll', 'cvdcclib64.dll', 'dctmdclib64.dll', 'eula.pdf', 'gams.exe', 'gamscmex.exe', 'gamserrs.txt', 'gamsgetkey.exe', 'gamslice.txt', 'gamsprobe.exe', 'gdxcclib64.dll', 'gevopt.def', 'gmdcclib64.dll', 'gmscmpNT.txt', 'gmscvnnt.cmd', 'gmscvnnx.exe', 'gmsgennt.cmd', 'gmsgennx.exe', 'gmske_nt.cmd', 'gmske_nx.py', 'gmsprmNT.txt', 'gmszlib164.dll', 'gsscclib64.dll', 'guccclib64.dll', 'gurobi110.dll', 'ipocclib64.dll', 'ipopt64.dll', 'joatdclib64.dll', 'libcrypto-3-x64.dll', 'libifcoremd.dll', 'libiomp5md.dll', 'libmmd.dll', 'mkl_gams.dll', 'msvcp140.dll', 'optconopt.def', 'optconvert.def', 'optcplex.def', 'optdclib64.dll', 'optgams.def', 'optipopt.def', 'optnlpec.def', 'optpath.def', 'path51.dll', 'ptccclib64.dll', 'pthreads.dll', 'shtcclib64.dll', 'svml_dispmd.dll', 'vcruntime140.dll', 'vcruntime140_1.dll']

file_paths = [directory + os.sep + file for file in files]
